/* global chrome */

(function insertAlertFrame() {
    var $iframeAlert, $iframeContents, $ndlAlert, imgNdl, imgNdlGif;
    var $png, $gif;
    var docHidden, docVisibilityChange;
    //Duration to make alert visible 25s
    //var alertVisibilityDuration = 3000;//for test 
    var alertVisibilityDuration = 25000;
    var alert = {
        init: function () {
            if ($('#ndl-iframe-alert').length > 0) {
                return;
            }
            var ihtml = chrome.runtime.getURL('content-alert.html');
            var alertCss = chrome.runtime.getURL('content/css/content-alert.css');
            var lineAwsFont = chrome.runtime.getURL('content/line-awesome/line-awesome.min.css');
            imgNdl = chrome.runtime.getURL('img/popup/needle-no-fil-40.png');
            imgNdlGif = chrome.runtime.getURL('img/needle-anime.gif');
            // imgNdlLinkAdded = chrome.runtime.getURL('img/popup/needle-fil-40.png');

            $iframeAlert =
                $('<iframe id="ndl-iframe-alert" name = "ndl-iframe-alert" scrolling = "no"\
                        frameborder= "0" allowtransparency = "true"> </iframe>');

            $('body').append($iframeAlert);
            $iframeContents = $iframeAlert.contents();
            $iframeContents.find('head').append(
                '<link rel="stylesheet" href="' + lineAwsFont + '">\
                    <link rel="stylesheet" href="' + alertCss + '">'
            );
            //TODO: remove load and place html directly here
            $iframeContents.find('body').load(ihtml + ' .ndl-alert', function () {
                $ndlAlert = $iframeContents.find('.ndl-alert');

                $png = $ndlAlert.find('.needle-bouton');
                $gif = $ndlAlert.find('.needle-anime');
                $png.attr('src', imgNdl);
                $gif.attr('src', imgNdlGif);

                var timeoutEnter, timeoutHideAlert;
                $ndlAlert.mouseenter(function () {
                    $png.attr('src', imgNdlGif);
                    //remove gif after animation
                    timeoutEnter = setTimeout(function () {
                        $png.attr('src', imgNdl);
                    }, 1200);
                    clearTimeout(timeoutHideAlert);
                }).mouseleave(function () {
                    $png.attr('src', imgNdl);
                    clearTimeout(timeoutEnter);
                    //remove alert after 25s
                    timeoutHideAlert = setTimeout(function () {
                        alert.hide();
                    }, alertVisibilityDuration);
                });

                var message = {
                    sender: 'alertFrame',
                    "message": "getAlertFrameData",
                    body: null
                };
                alert.sendMsgToExtension(message);

                // Set the name of the hidden property and the change event for visibility
                if (typeof document.hidden !== "undefined") {
                    docHidden = "hidden";
                    docVisibilityChange = "visibilitychange";
                } else if (typeof document.webkitHidden !== "undefined") {
                    docHidden = "webkitHidden";
                    docVisibilityChange = "webkitvisibilitychange";
                }
                //Listen to page visibility to show alert
                document.addEventListener(docVisibilityChange, function () {
                    if (document[docHidden]) {
                        $iframeAlert.remove();
                    }
                });
            });
        },
        sendMsgToExtension: function (message) {
            chrome.runtime.sendMessage(message, function (response) {
                if (!response) {
                    return;
                }
                var msgBody = response.body;
                var responseSender = response.respMessageTo;
                switch (responseSender) {
                    case 'getAlertFrameData':
                        //var max = 30000, min = 15000;//between 15 et 30 seconds
                        var max = 5000,
                            min = 2000; //for test
                        var duration = Math.floor(Math.random() * (max - min + 1) + min);
                        var timeoutShowAlert = setTimeout(function () {
                            if (!document.hidden) {
                                var title = msgBody.title;
                                if (title.length > 140) {
                                    title = title.substring(0, 137) + '...';
                                }
                                $ndlAlert.find('.page-title').html(title);
                                var iframeHeight = $ndlAlert.outerHeight(true) + 4 + 'px !important';
                                $iframeAlert.attr('style', 'height: ' + iframeHeight + '; max-height: ' + iframeHeight);
                                $iframeAlert.addClass('show');
                                clearTimeout(timeoutShowAlert);
                                //                                //remove alert after 25s
                                var timeoutHideAlert = setTimeout(function () {
                                    if (!$iframeAlert.is(':hover')) {
                                        alert.hide();
                                        clearTimeout(timeoutHideAlert);
                                    }
                                }, alertVisibilityDuration);

                            } else {
                                alert.hide();
                                clearTimeout(timeoutShowAlert);
                            }
                        }, duration);

                        $ndlAlert.find('.ndl-close-alert').click(function () {
                            alert.hide();
                            var message = {
                                message: "hide-alert",
                                body: null
                            };
                            chrome.runtime.sendMessage(message, function (response) {
                            });
                        });
                        break;
                }
            });
        },
        receiveMsgFromExtension: function () {
            chrome.runtime.onMessage.addListener(function (request, sender, sendResponse) {
            });
        },
        hide: function () {
            $iframeAlert.removeClass('show');
            setTimeout(function () {
                $iframeAlert.remove();
            }, 2000);
        }
    };

    alert.init();
    alert.receiveMsgFromExtension();
})();