var bg = window.chrome.extension.getBackgroundPage();
//remove scripts from html page
function stripScripts(s) {
    var div = document.createElement('div');
    div.innerHTML = s;
    var scripts = div.getElementsByTagName('script');
    var i = scripts.length;
    while (i--) {
        scripts[i].parentNode.removeChild(scripts[i]);
    }
    return div.innerHTML;
}
//replace src to prevent browser from fetching imgs
function replaceAll(str, find, replace) {
    var findStr = find.join('|');
    return str.replace(new RegExp(findStr, 'g'), replace);
}

var articles = {
    addArticle: function (article) {
        var url = article.url,
            title = article.title,
            date = utils.articleDates(article.created_at);
        var $article =
            $(`<article class="row">\
                <div class="col-sm-3 img-article">
                    <a href="${url}" target="_blank" rel="noopener">
                        <!--<img src="/img/theconversation-logo.png" class="img-responsive" alt="">-->
                    </a>
                </div>
                <div class="col-sm-9 article-body">
                    <h3 class="article-title">
                        <a href="${url}" target="_blank" rel="noopener">${title}</a>
                    </h3>
                    <p class="text-muted"><span class="glyphicon glyphicon-calendar"></span>
                        Ajouté au réseau needle pour la première fois le ${date}</p>
                    <p class="article-resume"></p>
                </div>
                <div class="theconversation_site">
                    <a class="ui red tag label" href="https://theconversation.com" 
                    target= "_blank" rel="noopener">Theconversation.com</a>
                </div>
            </article>
            <hr>`);
        $('.articles').append($article);
        var $preloader =
            $('<div class="preloader">\
                <svg class="circular-loader" viewBox="25 25 50 50" style="height: 50%">\
                <circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/>\
                </svg>\
            </div>');
        var $imgArticle = $('<img src="/img/theconversation-logo.png" class="img-responsive" alt="">');
        var $linkArticle = $article.find('.img-article a');
        $linkArticle.html($preloader);
        this.getTheConversationArticle(article.url, function (res) {
            if (res.error) {
                $linkArticle.html($imgArticle);
                return;
            }
            var imgsrc = res.imgsrc;
            var resume = res.resume;
            if (imgsrc) {
                $imgArticle.attr('src', imgsrc);
            }
            if (resume) {
                $article.find('.article-resume').html(resume);
            }
            $linkArticle.fadeOut('slow', function () {
                $(this).html($imgArticle);
                $(this).fadeIn('slow');
            });


        });
    },
    getListArticles: function (page) {
        $('.articles, .pagination').empty();
        var $preloader = $('.preloader');
        $preloader.show();
        var data = {
            page: page
        };
        // bg.loginManager.getArticles(data).then(function (res) {
        bg.api.getArticles(data, function (res) {
            utils.debug(res);
            if (!res.error) {
                var listArticles = res.articles;
                for (var i = 0; i < listArticles.length; i++) {
                    articles.addArticle(listArticles[i]);
                }
                $preloader.hide();
                //                articles.getPaginationCount(offset);
                articles.pagination(res);
            }
            $preloader.hide();
        });
    },
    generatePaginationRange: function (current, last) {
       
        var delta = 2,
            left = current - delta,
            right = current + delta + 1,
            range = [],
            rangeWithDots = [],
            tmpVal, val;

        for (var i = 1; i <= last; i++) {
            if (i === 1 || i === last || i >= left && i < right) {
                range.push(i);
            }
        }
        for (var i = 0; i < range.length; i++) {
            val = range[i];
            if (tmpVal) {
                if (val - tmpVal === 2) {
                    rangeWithDots.push(tmpVal + 1);
                } else if (val - tmpVal !== 1) {
                    rangeWithDots.push('...');
                }
            }
            rangeWithDots.push(val);
            tmpVal = val;
        }

        return rangeWithDots;
    },
    pagination: function (data) {        
        var paginationValues = articles.generatePaginationRange(data.current_page + 1, data.total_page + 1);
        var totalPages = data.total_page + 1;
        
        if (totalPages <= 1) {
            return;
        }
        var currentPage = data.current_page + 1;
        var li = '',
            val;
        for (var i = 0; i < paginationValues.length; i++) {
            val = paginationValues[i];
            if (currentPage === val) {
                li += '<li class="active">' + val + '</li>';
            } else if (val === '...') {
                li += '<li class="separator">' + val + '</li>';
            } else {
                li += '<li>' + val + '</li>';
            }
        }
        var $ul = $('<ul></ul>').append(li);
        //add arrows
        if (currentPage !== 1) {
            $ul.prepend('<li class="pagination-prev"><i class="arrow left icon"></i></li>');
        }
        if (currentPage !== totalPages) {
            $ul.append('<li class="pagination-next"><i class="arrow right icon"></i></li>');
        }

        $('.pagination').html($ul.children());
        $('.pagination li:not(.separator, .active)').click(function () {
            var page;
            if ($(this).hasClass('pagination-prev')) {
                page = currentPage - 1;
            } else if ($(this).hasClass('pagination-next')) {
                page = currentPage + 1;
            } else {
                page = $(this).text();
                page = parseFloat(page);
            }
            if (!isNaN(page)) {
                var stateObj = {
                    'page': page
                };
                history.pushState(stateObj, '', 'articles.html?page=' + page);
                articles.getListArticles(--page);
            }
        });
    },

    //crawler theconversation for articles img and resume
    getTheConversationArticle: function (url, callback) {
        var data = {};
        bg.api.getExteranl(url, data, function (htmlPage) {
            if (!htmlPage || htmlPage.error) {
                callback && callback({
                    error: true
                });
                return;
            }
            var body = htmlPage.substr(htmlPage.indexOf('<body'));
            body = body.substr(0, body.indexOf('</body>'));
            var changeSrc = replaceAll(body, ['src', 'data-src'], 'imgsrc');
            var noScriptBody = stripScripts(changeSrc);
            var imgsrc = $(noScriptBody).find('article').first().find('img[imgsrc*="theconversation.imgix.net/files"]').first().attr('imgsrc');
            var resume = $(noScriptBody).find('[itemprop=articleBody]').first().find('p').first().text();
            if (!imgsrc) {
                imgsrc = $(noScriptBody).find('article').first().find('img[imgsrc*="https://images.theconversation.com/files"]').first().attr('imgsrc');
            }
            //https://images.theconversation.com/files/161778/original/image-20170321-5368-5wnh14.jpg?ixlib=rb-1.1.0&amp;q=45&amp;auto=format&amp;w=926&amp;fit=clip
            if (resume.trim().length === 0) {
                var resumeSpan = $(noScriptBody).find('.content-body, .content').first().find('span').first().text();
                var resumeP = $(noScriptBody).find('.content-body, .content').first().find('p').first().text();
                resume = resumeSpan.trim().length > 0 ? resumeSpan : resumeP;
            }
            var data = {
                imgsrc: imgsrc,
                resume: resume,
                error: false
            };
            callback && callback(data);
        });
    }
};

//history while using pagination
window.onpopstate = function (event) {
    var state = event.state;
    var page = state ? (state.page - 1) : 0;
    articles.getListArticles(page);
};

$(function () {
    //    return
    var url = window.location.href;
    var parsedUri = utils.parseUri(url);
    var page = parsedUri.queryKey.page;
    page = page ? --page : 0;
    articles.getListArticles(page);
    
    var nagArticleHidden = localStorage.getItem('nag_art_state');
    nagArticleHidden = !!nagArticleHidden;
    if(!nagArticleHidden){
        $('.ui.message').show('blind');
    }

    $('.close').click(function () {
        localStorage.setItem('nag_art_state', 'true');
        $(this).closest('.message').transition('fade');
    });

});