// adding navigation bar
var bg = window.chrome.extension.getBackgroundPage();
// $('body:not(.discover, .home)').prepend(bg.getNavbar());
$(function () {
    //add the side Menu
    $('body').prepend(bg.getSideMenu());
    
    $('a.disconnect').click(function () {
        bg.userManager.logOut();
    });
    
    $('a.invitations').click(function () {
        invitations.init();
    });

    var $mainHeader = $('.ndl-main-header');
    var $stickyHeader = $('.ndl-sticky-header');
    var $mobileHeader = $('.ndl-mobile-header');

    function showHeaders() {
        var showStickyHeader = (!isInViewPort($mainHeader) && !$mobileHeader.is(':visible'));
        $stickyHeader.toggleClass('header-appear', showStickyHeader);
        var showMobileHeader = $mobileHeader.is(':visible') && !showStickyHeader;
        $mobileHeader.toggleClass('ndl-animate-mobile-header mobile-header-appear', showMobileHeader);
    }

    showHeaders();
    $(window).resize(function () {
        showHeaders();
    });
    $(window).scroll(function () {
        showHeaders();
    });
    //Detect viewport (header visibility)
    function isInViewPort($element) {
        if ($element.length === 0) { //where main certains header does not exist (home.html)
            return false;
        }
        var topOfElement = $element.offset().top;
        var bottomOfElement = $element.offset().top + $element.outerHeight() + 20; //+20 to not show immediately
        var bottomOfScreen = $(window).scrollTop() + window.innerHeight;
        var topOfScreen = $(window).scrollTop();
        return ((bottomOfScreen > topOfElement) && (topOfScreen < bottomOfElement));
    }


    // ============Mobile nav opener==================
    $('.ndl-mobile-menu-opener').click(function () {
        $(this).toggleClass('ndl-mobile-active');
        $('nav.ndl-mobile-nav').slideToggle('ndl-mobile-nav-opened');
    });
    $('.menu-item.has-sub_menu').click(function () {
        $(this).toggleClass('ndl-opened').find('.sub_menu').slideToggle('ndl-opened');
    });
    // ============Open close side menu==================
    $('.ndl-user-account, .ndl-mobile-account-opener').click(function () {
        $('body').addClass('ndl-right-side-menu-opened');
    });
    $('.ndl-side-menu a').click(function (e) {
        e.preventDefault();
        var url = $(this).prop('href');
        $('body').removeClass('ndl-right-side-menu-opened');
        setTimeout(function () {
            if (url) {
                window.location.href = url;
            }
        }, 300);
    });
    $('.ndl-close-side-menu, .ndl-cover').click(function () {
        $('body').removeClass('ndl-right-side-menu-opened');
    });

    //init support and bug report modal

    bugManager.addBugAction();

});


var bugManager = {
    addBugAction: function () {
        $('body').append(
            '<div class="bug-report-action-btn"\
                        data-tooltip="Un bug? Un problème? Dites-le nous !" data-position="left center">\
                        <i class="la la-bug"></i>\
                    </div>'
        );
        $('.bug-report-action-btn').click(function () {
            //bugManager.addBugReportModal();
            bugManager.reportBug();
            //$('.bug-report-modal').modal('show');
        });
    },
    reportBug: function () {
        if ($('.bug-report-dimmer').length > 0) {
            return;
        }
        var modal = `<div class="ui dimmer page bug-report-dimmer">
                <div class="ui scrolling modal bug-report-modal">
                    <div class="modal-body" >
                        <div class="content">
                            <h3 class="ui header">Un bug ? Un problème ? Dites-le nous</h3>
                            <div class="ui form" id="bug-report-form">
                                <div class="title">
                                    Si vous rencontrez la moindre difficulté dans l'utilisation de needle 
                                    ou si quelque chose vous semble manquer, merci de nous en faire part. 
                                    Veuillez à nous apporter toutes les précisions qui pourraient nous aider 
                                    à comprendre votre situation 
                                    (modèle du navigateur, configuration particulière de votre ordinateur...)
                                </div>
                                <div class="field">
                                    <textarea placeholder="Décrivez le problème ou le bug rencontré"></textarea>
                                    <div class="ndl-message ndl-message-error"></div>
                                    <div class="ndl-message ndl-message-success"></div>
                                </div>
                            </div>
                        </div>
                        <div class="actions">
                            <div class="ui button close-btn">Fermer</div>
                            <div class="ui button send-btn">Envoyer</div>
                        </div>
                    </div>
                </div>
            </div>`;
        $('body').append(modal);

        var $bugReportModal = $('.bug-report-modal');
        var $bugReportForm = $('#bug-report-form');
        var $errorMsg = $('.bug-report-modal .ndl-message-error');
        var $successMsg = $('.bug-report-modal .ndl-message-success');
        var $areaMessage = $('.bug-report-modal textarea');

        $bugReportModal.modal({
            closable: false,
            onHidden: function () {
                $bugReportForm.removeClass('error success');
                $('.send-btn').removeClass('loading');
                $areaMessage.val('');
            },
            onHide: function () {

            }
        }).modal('show');
        $('.bug-report-action-btn').click(function () {
            $bugReportModal.modal('show');
        });
        $('.bug-report-modal .close-btn').click(function () {
            $bugReportModal.modal('hide');
        });

        $areaMessage.focusin(function () {
            $bugReportForm.removeClass('error success');
        });


        $('.bug-report-modal .send-btn').click(function () {
            var message = $areaMessage.val();
            if (!message || message.trim().length === 0) {
                $errorMsg.text('Ce Champ est requis.');
                $bugReportForm.addClass('error');
                return;
            }
            var $this = $(this);
            $this.addClass('loading');
            bg.groupsManager.api.bugRepport(message, function (res) {
                if (!res.error) {
                    $successMsg.html('Message envoyé. <br> Nous vous remercions pour votre message.');
                    $bugReportForm.removeClass('error').addClass('success');
                    $areaMessage.val('');
                } else {
                    $errorMsg.text(res.message || NDLConst.ERR_GLOBAL);
                    $bugReportForm.removeClass('success').addClass('error');
                }
                $this.removeClass('loading');
            });

        });
    }
};

/**
 * Invite people to join neelde
 */
var invitations = {
    template: function () {
        var t = `<div class="popup-fil popup-invites">
            <div class="popup-content-wrapper">
                <div class="popup-body">
                    <div class="content">
                        <h3 class="header">
                            <span>Invitation</span>
                            <button class="close">
                                <i class="la la-close"></i>
                                <span class="esc">esc</span>
                            </button>
                        </h3>
                        <div class="ui form form-invite">
                            <div class="invite-message">Inviter d'autres utilisateurs à rejoindre le réseau needle</div>
                            <div class="field">
                                <label for="email">Adresse e-mail</label>
                                <div class="ui fluid input">
                                    <input type="email" name="email" id="email" placeholder="nom@domain.tld"/>
                                </div>
                            </div>
                            <div class="ndl-message ndl-message-error">error</div>
                            <div class="ndl-message ndl-message-success">success</div>
                        </div>
                    </div>
                    <div class="actions">
                        <div class="ui button close-popup-btn">Annuler</div>
                        <div class="ui button btn-validate btn-send-invite">Envoyer</div>
                    </div>
                </div>
            </div>
        </div>`;
        return $(t);
    },
    init: function(){
        var $pageContent = $('.page-content');
        if($pageContent.length === 0){
            utils.debug('page content not found');
            return;
        }
        var $popupInvites = $(this.template()),
            $popupBody = $popupInvites.find('.popup-body');

        $pageContent.append($popupInvites);
        $popupInvites.addClass('active');


        var $btnSendInvite = $popupInvites.find('.btn-send-invite'),
            $emailInput = $popupBody.find('input'),
            $successMsg = $popupBody.find('.ndl-message-success'),
            $errorMsg = $popupBody.find('.ndl-message-error');
            
        $btnSendInvite.click(function(){
            var email = $emailInput.val().trim();
            console.log(email);
            
            if (!email || email.trim().length === 0) {
                $errorMsg.text('Ce Champ est requis.');
                $popupInvites.addClass('error');
                return;
            }
            var $this = $(this);
            var data = {
                method: 'invites',
                email: email
            };
            $this.addClass('loading');
            bg.api.userActionPost(data, function(res){
                utils.debug(res);
                $this.removeClass('loading');
                if(res.error){
                    $errorMsg.text(res.message || NDLConst.ERR_GLOBAL);
                    $popupInvites.removeClass('success').addClass('error');
                    return;
                }
                var message = res.message;
                message = message.replace('$email', 
                    '<b class="email">'+email+'</b>');
                $successMsg.html(message);
                $emailInput.val('');
                $popupInvites.removeClass('error').addClass('success');
                
            });

        });

        $emailInput.focusin(function () {
            $popupInvites.removeClass('error success');
        });

        $popupInvites.find('.close-popup-btn, .header .close')
            .click(function () {
                $popupInvites.remove();
            });
        $popupInvites.click(function (e) {
            if ($('.popup-content-wrapper', this).is($(e.target))) {
                $popupBody.effect('shake', {
                    times: 2,
                    distance: 5
                });
            }
        });

        $(document).off('keyup').keyup(function(e){
            if(e.keyCode === 27){
                $popupInvites.remove();
            } 
        });
        
        
    },
};