/**
 * utility for extension only NO content script
 */

var chromeAPI = {
    createTab: function (url, cb) {
        var queryInfo = {
            url: url,
            active: true
        };
        chrome.tabs.create(queryInfo, function (tab) {
            cb && cb(tab);
        });
    },
    getActiveTab: function (cb) {
        var queryInfo = {
            active: true,
            currentWindow: true
        };
        chrome.tabs.query(queryInfo, function (tabs) {
            cb && cb(tabs[0]);
        });
    },
    getActiveWinTabs: function (cb) {
        var queryInfo = {
            currentWindow: true
        };
        chrome.tabs.query(queryInfo, function (tabs) {
            cb && cb(tabs);
        });
    },
    getTabDetails: function (tabId, cb) {
        chrome.tabs.get(tabId, function (tab) {
            if (chrome.runtime.lastError) {
                tab = null;
            }
            cb && cb(tab);
        });
    },
    getTabIndex: function(tabId, cb){
        this.getActiveWinTabs(function (tabs) {
            for (let i = 0; i < tabs.length; i++) {
                if(tabs[i].id === tabId){
                    return cb(i);
                }
            }
            //not found, return last tab index
            var len = tabs.length - 1;
            len = len > 0? len : 0;
            cb(len);
        });
    },
    /**
     * Check if an extension url is open in a tab of current window
     * @param {type} path path in extension
     * @param {function} cb
     * @returns {Object}   the tab infos  */
    isExtensionUrlOpen: function (path, cb) {
        //match patern
        var url =  chrome.runtime.getURL(path) + '*';
        var queryInfo = {
            currentWindow: true,
            url: url
        };
        
        chrome.tabs.query(queryInfo, function (tabs) {
            var tab = tabs.length > 0? tabs[0] : null;
            cb && cb(tab);
        });
    }
};