/**
 * View fil when title fil is clicked in history, followed/memorize, group-info
 */
(function () {
    var bg = chrome.extension.getBackgroundPage();
    var viewFil = {
        init: function () {
            var urlParams = utils.urlParams(window.location.href),
                idRef = urlParams.ref,
                linkId = urlParams.link_id,
                userCle = urlParams.cle;
            if (!userCle || userCle.length === 0) {
                return commons.showPageMessage(
                    NDLConst.ERR_FIL_NOT_FOUND, 'info');
            }
            $('head title').text('Fil-'+userCle);
            if (!idRef || !utils.isNumeric(idRef) || !linkId || !utils.isNumeric(linkId)) {
                return commons.showPageMessage(
                    NDLConst.ERR_REF_NOT_FOUND, 'info');
            }
            var params = {
                method: 'init',
                user_cle: urlParams.cle,
                link_id: urlParams.link_id,
                id_ref: urlParams.ref,
                filter: urlParams.filter,
                term: urlParams.term,
                selected_tags: urlParams.selected_tags
            };
            
            var $pageContent = $('.page-content');
            $pageContent.addClass('loading');
            bg.api.getFilData(params, function (res) {
                utils.debug(res);
                $pageContent.removeClass('loading');
                if (res.error) {
                    return commons.showPageMessage(res.message || NDLConst.ERR_GLOBAL);
                }
                var user = res.user;
                var $fil = $('.fil');
                //update fil title
                $fil.find('.fil-title .title-text .title').text(user.title);
                $('.fils-container').addClass('ndl-active');
                //unique fil
                $fil.addClass('fil-' + user.cle);

                var swiper = commons.createSwiper(user.cle);
                if (null === swiper) {
                    utils.debug('ERR_INIT_SWIPER');
                    return;
                }

                var linkId = urlParams.ref,
                    initialSlide = -1;

                if (linkId) {
                    initialSlide = utils.findIndexRef(res.refs, 'link_id', +linkId);
                }
                if (initialSlide < 0) {
                    initialSlide = 0;
                    if (res.refs.length > 3) {
                        initialSlide = res.refs.length - 2;
                    }
                }

                linkId = res.refs[initialSlide].link_id;

                var isInit = commons.initializeSwiper(res, initialSlide, swiper);
                if (isInit) {
                    var cssClass = '';
                    var userData = bg.userManager.getUser(),
                        currentUser = userData.user;
                    if (user.cle === currentUser.cle) {
                        cssClass = 'teal';
                    }else {
                        var  src = urlParams.s;
                        if (src === 'h') {
                            // from history
                            cssClass = 'blue';
                        } else if (src === 'm') {
                            //from memorized/followed
                            cssClass = 'purple';
                        } else if (src === 'g') {
                            //from group
                            cssClass = 'green';
                        }
                    }
                    $fil.addClass(cssClass);
                    var $searchBar = $('.searchbar');
                    commons.search.init(swiper, $searchBar);
                    //init cross filter
                    var $checkbox = $('.checkbox-cross');
                    commons.initFilterCross(swiper, $checkbox);
                }
            });
        }
    };

    $(document).ready(function () {
        viewFil.init();
    });
})();